/*******************************************************************
 *
 *	File:		CArloConfig.h
 *
 *	Author:		Peter van Sebille (peter@yipton.demon.co.uk)
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __C_ARLO_CONFIG__H
#define __C_ARLO_CONFIG__H

const TInt		KMaxConfigTextString = 64;
typedef TBuf<KMaxConfigTextString>	TKernelFileName;
typedef TBuf<KMaxConfigTextString>	TInitrdFileName;
typedef TBuf<KMaxConfigTextString>	TDescription;
typedef TBuf<KMaxConfigTextString>	TBootString;


class TArloBootItem
{
public:
	TKernelFileName		iKernelFileName;
	TInitrdFileName		iInitrdFileName;
	TDescription		iDescription;
	TBootString			iBootString;
};


class CArloConfig : public CBase
{
public:
	~CArloConfig();
	static CArloConfig* ReadConfigFileLC();
	
	TInt BootItems(){return iArloBootItems->Count();}
	TInt DefaultBootItem(){return iDefaultBootItem;}
	TInt Timeout(){return iTimeout;}
	const TArloBootItem& BootItemL(TInt aItem){return iArloBootItems->At(aItem);}
	const TDesC& MachineName() {return iMachineName;}
	const TDesC& UsedConfigFile() {return iConfigFile;}

protected:
	CArloConfig();
	void ConstructL();
	void ReadConfigFileL(RFs& aFs, const TDesC& aFileName);
	void ParseLine(const TDesC& aLine);
	void ParseItems(const TDesC& aToken, const TDesC&  aValue);
	void NewBootItem(const TDesC& aBootItem);
	void SetDefaultBootItem();

	void Defaults();

	TInt			iTimeout;
	TInt			iDefaultBootItem;
	TDescription	iDefaultBootItemString;
	TInfoName		iMachineName;
	TInfoName		iConfigFile;
	CArrayFixFlat<TArloBootItem>*	iArloBootItems;
};


#endif			/* __C_ARLO_CONFIG__H */